unit mcClientAPI;

interface

uses Windows, mcplugin_info, superobject;

const
  pluginsAPIVersionMajor = 5;
  pluginsAPIVersionMinor = 0;
  CRLF             = #13#10;

  MCC_On_ChatFocused                             = 1; // +
  MCC_On_ChatLostFocus                           = 2; // +
  MCC_On_ConsoleEvents                           = 3; // +
  MCC_On_GetUserActiveCaption                    = 4; //      ,     
  MCC_On_ChannelMessage                          = 5; // +
  MCC_On_LoginSucess                             = 6; // +
  MCC_On_NewTxtChannelAdded                      = 7; // +
  MCC_On_JoinTxtChannel                          = 8; // +
  MCC_On_JoinNewbieToTxtChannel                  = 9; // +
  MCC_On_PrivateMessageOffline                   = 10; // +
  MCC_On_ShowOptions                             = 11; // +
  MCC_On_ShowPluginWindow                        = 12; // +
  MCC_On_ClickPopupMenuContactsGroup             = 13; // +
  MCC_On_ClickPopupMenuContactsUser              = 14; // +
  MCC_On_ClickPopupMenuChannelUsersList          = 15; // +
  MCC_On_ClickPopupMenuChannelWindowUIN          = 16; // +
  MCC_On_ClickPopupMenuChannelWindowSelectedText = 17; // +
  MCC_On_ClickPopupMenuChannelWindowText         = 18; // +
  MCC_On_ClickPopupMenuPrivateWindowSelectedText = 19; // +
  MCC_On_ClickPopupMenuPrivateWindowText         = 20; // +
  MCC_On_ClickTopMenuPrivateWindowUIN            = 21; // +
  MCC_On_PrivateMessage                          = 22; // +
  MCC_On_PersonalChannelMessage                  = 23; // +
  MCC_On_AlertChannelMessage                     = 24; // +
  MCC_On_ChangeChannelTopic                      = 25; // +
  MCC_On_KillTxtChannel                          = 26; // +
  MCC_On_UserLeaveTxtChannel                     = 27; // +
  MCC_On_Error                                   = 28; // +
  MCC_On_UserDisconnect                          = 29; // +
  MCC_On_UserIP                                  = 30;
  MCC_On_RawDataToUser                           = 31;
  MCC_On_PrivateBeep                             = 32;
  

  MCC_Send_MessageToTextChannel         = 1;
  MCC_Send_PrivateMessage               = 2;
  MCC_Send_PersonalMessageToTextChannel = 3;
  MCC_Send_AlertMessageToTextChannel    = 4;
  MCC_Send_ChangeTextChannelTopic       = 5;
  MCC_Send_AdmBanUser                   = 6;
  MCC_Send_AdmKickUser                  = 7;
  MCC_Send_AdmKillUser                  = 8;
  MCC_Send_AdmBlockIP                   = 9;
  MCC_Send_AdmBlockMAC                  = 10;
  MCC_Send_RawDataToUser                = 11;
  MCC_Send_RawDataToChannel             = 12;
  MCC_Send_ClearTextChannel             = 13;
  MCC_Send_ClearTextPrivate             = 14;
  MCC_Send_ConsoleCommand               = 15;
  MCC_Send_LoadOptions                  = 16;
  MCC_Send_SelectChannel                = 17;
  MCC_Send_SelectPrivate                = 18;
  MCC_Send_SelectConsole                = 19;
  MCC_Send_Log                          = 20;

  MCC_Get_ContactsList       = 1;
  MCC_Get_ChannelUsersList   = 2;
  MCC_Get_ChannelsList       = 3;
  MCC_Get_ActivePrivate      = 4;
  MCC_Get_ActiveChannel      = 5;
  MCC_Get_UserQuickInfo      = 6;
  MCC_Get_UserFullInfo       = 7;
  MCC_Get_IsTextChannelOpen  = 8;
  MCC_Get_IsPrivateOpen      = 9;
  MCC_Get_ChannelName        = 10;
  MCC_Get_MyStatus           = 11;
  MCC_Get_IsConnected        = 12;
  MCC_Get_SmileCode          = 13;
  MCC_Get_IsPluginLoaded     = 14;
  MCC_Get_UserActiveCaption  = 15;
  MCC_Get_ActiveLocale       = 16;
  MCC_Get_PluginFolder       = 17;
  MCC_Get_ComputerHardwareID = 18;
  MCC_Get_MyUIN              = 19;

type
  TmcSendDataToMyChat  = procedure(iCmd: DWORD; sJSONData: WideString);safecall;
  TmcGetDataFromMyChat = function(iCmd: DWORD; sJSONData: WideString): WideString;safecall;

function mcPluginsAPIMajor: DWORD;safecall;
function mcPluginsAPIMinor: DWORD;safecall;
function mcLoadPlugin(approc1: TmcSendDataToMyChat; approc2: TmcGetDataFromMyChat): HRESULT;safecall;
function mcPluginGetInfo: WideString;safecall;


var
  mcSendDataToMyChat  : TmcSendDataToMyChat;
  mcGetDataFromMyChat : TmcGetDataFromMyChat;

exports
  mcPluginsAPIMajor,
  mcPluginsAPIMinor,
  mcLoadPlugin,
  mcPluginGetInfo;

implementation

function mcPluginsAPIMajor: DWORD;safecall;
begin
  result := pluginsAPIVersionMajor;
end;

function mcPluginsAPIMinor: DWORD;safecall;
begin
  result := pluginsAPIVersionMinor;
end;

function mcLoadPlugin(approc1: TmcSendDataToMyChat; approc2: TmcGetDataFromMyChat): HRESULT;safecall;
begin
  mcSendDataToMyChat  := approc1;
  mcGetDataFromMyChat := approc2;

  result := integer(true);
end;

function mcPluginGetInfo: WideString;safecall;
var
  JSONobj: ISuperObject;
begin
  JSONobj := SO();

  JSONobj.S['Name']        := pluginName;

  JSONobj.S['Copyright']   := pluginCopyright;
  JSONobj.S['Version']     := pluginVersion;
  JSONobj.S['ReleaseDate'] := pluginReleaseDate;

  JSONobj.S['CaptionEN']   := PluginCaptionEN;
  JSONobj.S['CaptionRU']   := PluginCaptionRU;
  JSONobj.S['CaptionUA']   := PluginCaptionUA;

  JSONobj.S['WWW']         := pluginWWW;
  JSONobj.S['Email']       := pluginEmail;

  JSONobj.S['DescEN']      := pluginDescriptionEN;
  JSONobj.S['DescRU']      := pluginDescriptionRU;
  JSONobj.S['DescUA']      := pluginDescriptionUA;

  JSONobj.B['OptionsPresent']                  := pluginOptionsPresent;
  JSONobj.B['WindowPresent']                   := pluginWindowPresent;
  JSONobj.B['PopupMenuContactsPanel']          := pluginPopupMenuContactsPanel;
  JSONobj.B['PopupMenuUserInChannelText']      := pluginPopupMenuUserInChannelText;
  JSONobj.B['PopupMenuUserInChannelUsersList'] := pluginPopupMenuUserInChannelUsersList;
  JSONobj.B['PopupMenuPrivate']                := pluginPopupMenuPrivate;
  JSONobj.B['TopMenuPrivate']                  := pluginTopMenuPrivate;

  JSONobj.B['HookChannelMessages']   := pluginHookChannelMessages;
  JSONobj.B['HookPrivateMessages']   := pluginHookPrivateMessages;
  JSONobj.B['HookPersonalMessages']  := pluginHookPersonalMessages;
  JSONobj.B['HookAlertMessages']     := pluginHookAlertMessages;
  JSONobj.B['HookChannelTheme']      := pluginHookChannelTheme;

  JSONobj.B['ModerateMessages']      := pluginModerateMessages;

  result := JSONobj.AsJSon;

  JSONobj.Clear(true);
  JSONobj := nil;
end;

end.
